'CenterFrameHorizontally.csc
'Centers a frame between left and right margins.
'Copyright 2003-2004 by Abe Hendin <venturadev@yourspeed.com>. Public domain.
'Version 1.1
'April 29, 2004

'VERSION HISTORY:
'VERSION 1.1
'Script now accounts for frame captions.

'VERSION 1.01, June 1, 2003
'First release.

#ADDFOL "C:\Program Files\Corel\Graphics8\scripts"
#ADDFOL "C:\Program Files\Corel\Graphics8\ventura\Scripts"
#INCLUDE "scpconst.csi"
#INCLUDE "vpconst.csi"
#DEFINE APP_NAME				"CenterFrameHorizontally.csc"

#DEFINE FRAME_CAPTION_LEFT				4
#DEFINE FRAME_CAPTION_RIGHT				8
#DEFINE FRAME_CAPTION_LEFT_AND_RIGHT	12

WITHOBJECT "CorelVentura.Automation.8"
	DIM lSelectionType AS LONG
	DIM lFrameInd AS LONG, sFrameAnchorName AS STRING
	DIM lFrameWidth AS LONG, lSpaceMarginToFrame AS LONG, lFrameLeft AS LONG
	DIM lCaptionType AS LONG
	DIM lFrameCap1Width AS LONG, lFrameCap2Width AS LONG
	DIM lFrameCap1Left AS LONG, lFrameCap2Left AS LONG
	DIM lPageWidth AS LONG, lLeftMargin AS LONG, lRightMargin as long
	DIM iretval AS INTEGER
	DIM bLeftPage AS BOOLEAN
	
	'confirm that a frame is selected
	lSelectionType = .GetSelectionType()
	IF lSelectionType <> SELECT_FRAME THEN
		iretval = MESSAGEBOX("This script is designed to center only main " + \\
			"(not caption) frames." + CHR(10) + \\
			"Please select a main frame and try again.", APP_NAME, MB_OK_ONLY + MB_STOP_ICON)
		STOP
	ENDIF
	
	'confirm that the frame selected is not a caption frame
	.FormatFrameAnchorGet , , , , sFrameAnchorName
	IF sFrameAnchorName = "" THEN
		iretval = MESSAGEBOX("This script is designed to center only main " + \\
			"(not caption) frames." + CHR(10) + \\
			"Please select a main frame and try again.", APP_NAME, MB_OK_ONLY + MB_STOP_ICON)
		STOP
	ENDIF
	
	lFrameInd = .CurrentFrameIndex() 'get ref to current frame

	'get page width and L/R margins
	.FrameFirst TRUE
	.FormatFrameGeneralGet , , lPageWidth
	.CurrentPageNumber(bLeftPage) 'must test for pageside to get correct margins
	IF bLeftPage THEN
		.FormatFrameMarginsInsideGet 1, lLeftMargin, lRightMargin
	ELSE
		.FormatFrameMarginsInsideGet 2, lLeftMargin, lRightMargin
	ENDIF
	
	.FrameFirst FALSE, lFrameInd 'reselect frame
	
	'check for frame caption; if present, include in frame width calculation
	.FormatFrameGeneralGet , , lFrameWidth, , , , , lCaptionType
	SELECT CASE lCaptionType
		CASE FRAME_CAPTION_LEFT
			.FrameFirst FALSE, lFrameInd+1
			.FormatFrameGeneralGet , , lFrameCap1Width
			lFrameWidth = lFrameWidth + lFrameCap1Width
			lSpaceMarginToFrame = (lPageWidth - lLeftMargin - lRightMargin - lFrameWidth)/2
			lFrameLeft = lLeftMargin + lFrameCap1Width + lSpaceMarginToFrame
		
		CASE FRAME_CAPTION_RIGHT
			.FrameFirst FALSE, lFrameInd+1
			.FormatFrameGeneralGet , , lFrameCap1Width
			
			lFrameWidth = lFrameWidth + lFrameCap1Width
			lSpaceMarginToFrame = (lPageWidth - lLeftMargin - lRightMargin - lFrameWidth)/2
			lFrameLeft = lLeftMargin + lSpaceMarginToFrame
		
		CASE FRAME_CAPTION_LEFT_AND_RIGHT
			.FrameFirst FALSE, lFrameInd+1
			.FormatFrameGeneralGet lFrameCap1Left, , lFrameCap1Width
			
			.FrameFirst FALSE, lFrameInd+2
			.FormatFrameGeneralGet lFrameCap2Left, , lFrameCap2Width
			
			lFrameWidth = lFrameWidth + lFrameCap1Width + lFrameCap2Width
			lSpaceMarginToFrame = (lPageWidth - lLeftMargin - lRightMargin - lFrameWidth)/2
			
			'determine which caption is the CapLeft
			IF lFrameCap1Left < lFrameCap2Left THEN
				lFrameLeft = lLeftMargin + lFrameCap1Width + lSpaceMarginToFrame
			ELSE
				lFrameLeft = lLeftMargin + lFrameCap2Width + lSpaceMarginToFrame
			ENDIF
			
		CASE ELSE
			lSpaceMarginToFrame = (lPageWidth - lLeftMargin - lRightMargin - lFrameWidth)/2
			lFrameLeft = lLeftMargin + lSpaceMarginToFrame
	END SELECT
	
	'reposition frame
	IF lFrameWidth <= lPageWidth THEN
		.FrameFirst FALSE, lFrameInd
		.FormatFrameGeneral lFrameLeft
	ELSE
		iretval = MESSAGEBOX("Frame is wider than the page: cannot reposition.", \\
			"Processing parameters exceeded", \\
			MB_OK_ONLY + MB_STOP_ICON)
	ENDIF
END WITHOBJECT
